// Copyright (c) 2016-2018 Kiwano - Nomango
// 
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

#pragma once
#include "Actor.h"
#include "Frame.h"

namespace kiwano
{
	// 精灵
	class KGE_API Sprite
		: public Actor
	{
	public:
		Sprite();

		explicit Sprite(
			String const& file_path
		);

		Sprite(
			String const& file_path,
			Rect const& crop_rect	/* 裁剪矩形 */
		);

		explicit Sprite(
			Resource const& res
		);

		Sprite(
			Resource const& res,
			Rect const& crop_rect	/* 裁剪矩形 */
		);

		explicit Sprite(
			FramePtr frame
		);

		virtual ~Sprite();

		// 加载图像
		bool Load(
			String const& file_path
		);

		// 加载图像资源
		bool Load(
			Resource const& res
		);

		// 裁剪矩形
		void SetCropRect(
			const Rect& crop_rect
		);

		// 获取帧图像
		inline FramePtr GetFrame() const { return frame_; }

		// 设置帧图像
		void SetFrame(FramePtr frame);

		// 渲染精灵
		void OnRender(RenderTarget* rt) override;

	protected:
		FramePtr frame_;
	};
}
